// Made by Daniel J
// http://djazz.mine.nu/
// @daniel_hede

(function (global) {
	'use strict';
	
	// Basic options/variables
	var finalReleaseDate = '23 October 2014';
	var daysBefore = 180;
	var importantDays = [
		/*'7 June 2012',
		'28 June 2012',
		'2 August 2012',
		'6 September 2012',
		'27 September 2012'*/
	];
	var isAnimated = true;
	
	
	// The logic is below this line
	finalReleaseDate = new Date(finalReleaseDate).getTime();
	for(var i=0; i < importantDays.length; i++) {
		importantDays[i] = new Date(importantDays[i]).getTime();
	}
	var canvas = global.document.getElementById('canvas');
	var c = canvas.getContext("2d");
	var canvasBack = global.document.getElementById('canvasBack');
	var bc = canvasBack.getContext("2d");
	
	var logo = new Image();
	logo.src = 'ubuntu-logo.png';
	var startTime = new Date().getTime();
	if(top === self) {
		global.document.getElementById('hideWhenIframe').style.display = 'block';
	}
	var canvasRatio = top === self ? 3 : 1;
	canvas.width = canvasBack.width = ~~(180*canvasRatio);
	canvas.height = canvasBack.height = ~~(150*canvasRatio);
	var hasLoaded = false;
	var isFirefox = navigator.userAgent.indexOf('Firefox') !== -1;
	
	var version = global.document.getElementById('version');
	var status1 = global.document.getElementById('status1');
	var status2 = global.document.getElementById('status2');
	var container = global.document.getElementById('container');
	var rotater = global.document.getElementById('rotater');
	
	container.style.width = canvas.width + 'px';
	container.style.height = canvas.height + 'px';
	version.style.fontSize = 17*canvasRatio+'px';
	status2.style.fontSize = 14*canvasRatio+'px';
	status1.style.top = ~~(canvas.height/2-32*canvasRatio)+'px';
	status2.style.top = ~~(canvas.height/2+10*canvasRatio)+'px';
	
	var grad = c.createRadialGradient(canvas.width/2, canvas.height/2, 30, canvas.width/2, canvas.height/2, 75*canvasRatio);
	
	grad.addColorStop(0, 'rgba(255, 120, 0, 0.8)');
	grad.addColorStop(0.4, 'rgba(255, 96, 0, 0.8)');
	grad.addColorStop(1, 'rgba(244, 50, 0, 0.8)');
	
	var transformAliasArray = ['webkitTransform'];
	var transformAlias = 'transform';
	for(var i=0; i < transformAliasArray.length; i+=1) {
		if(canvas.style[transformAliasArray[i]] !== undefined) {
			transformAlias = transformAliasArray[i];
			break;
		}
	}
	
	var counter = 0;
	
	var redraw = function () {
		setTimeout(redraw, 1000/25);
		var now = new Date().getTime();
		var timeOffset = (now - startTime)/1000;
		
		if(!hasLoaded) {
			c.save();
			c.fillStyle = 'rgba(255, 255, 255, 0.8)';
			c.fillRect(0, 0, canvas.width, canvas.height);
			c.fillStyle = grad;
			c.translate(canvas.width/2, canvas.height/2);
			c.rotate(timeOffset*3);
			c.lineWidth = 5;
			c.shadowColor = 'orange';
			c.shadowBlur = 15;
			for(var i=0; i < 3; i+=1) {
				c.beginPath();
					c.arc(0, 0, 32*canvasRatio, i*Math.PI*(2/3), Math.PI/2+i*Math.PI*(2/3), false);
					c.arc(0, 0, 55*canvasRatio, Math.PI/2+i*Math.PI*(2/3), i*Math.PI*(2/3), true);
				c.closePath();
				c.fill();
			}
			c.restore();
			return;
		}
		c.clearRect(0, 0, canvas.width, canvas.height);
		bc.clearRect(0, 0, canvas.width, canvas.height);
		
		var timeLeft = finalReleaseDate - now;
		var daysLeft = Math.ceil(timeLeft/(24*60*60*1000));
		var msg;
		var line2 = '';
		var textsize = 45;
		if(daysLeft === 0) {
			msg = 'Coming soon';
			textsize = 28;
		}
		else if(daysLeft === 1) {
			msg = '1';
			line2 = 'day';
		}
		else if(timeLeft > 0) {
			msg = daysLeft;
			line2 = 'days';
		}
		else {
			msg = 'It\'s here!';
			textsize = 41;
		}
		status1.style.fontSize = textsize*canvasRatio + 'px';
		status1.innerHTML = msg;
		status2.innerHTML = line2;
		/*version.style.opacity = */status1.style.opacity = status2.style.opacity = Math.min(timeOffset*2, 1);
		
		var percentage = 1-Math.min(Math.max((timeLeft/(24*60*60*1000)/daysBefore), 0.00001), 0.9999);
		if(percentage === 0) percentage = 1;
		
		if(logo.complete) { // Logo loaded
			c.save();
			bc.save();
				// Animates the logo chart
				if(!isFirefox && isAnimated) {
					if(canvas.style[transformAlias] === undefined) {
						c.translate(canvas.width/2, canvas.height/2);
						c.scale(Math.cos(now/1500)/20+0.95, 1);
						c.rotate(Math.sin(now/3000)/5);
						c.translate(-canvas.width/2, -canvas.height/2);
						
						bc.translate(canvas.width/2, canvas.height/2);
						bc.scale(Math.cos(now/1500)/20+0.95, 1);
						bc.rotate(Math.sin(now/3000)/5);
						bc.translate(-canvas.width/2, -canvas.height/2);
					}
					else {
						var transformString = "rotateX("+(Math.sin(now/1500)*10-5)+"deg) rotateY("+(Math.cos(now/1500)*10-10)+"deg) rotateZ("+(Math.sin(now/2000)*5-2.5)+"deg)";
						canvas.style[transformAlias] = canvasBack.style[transformAlias] = transformString;
					}
				}
				
				// The overlay color (foreground)
				c.fillStyle = grad;
				c.fillRect(canvas.width/2-(150*canvasRatio)/2-9*canvasRatio, canvas.height/2-(150*canvasRatio)/2+3*canvasRatio, 148*canvasRatio, 148*canvasRatio);
				c.globalCompositeOperation = 'destination-in';
				c.drawImage(logo, canvas.width/2-(150*canvasRatio)/2-10*canvasRatio, canvas.height/2-(150*canvasRatio)/2+2*canvasRatio, 150*canvasRatio, 150*canvasRatio);
				
				c.globalCompositeOperation ='destination-out';
				c.beginPath();
					c.arc(canvas.width/2, canvas.height/2, 300*canvasRatio, 0, Math.PI*2*percentage, true);
					c.lineTo(canvas.width/2, canvas.height/2);
				c.closePath();
				c.fill();
				
				// Background logo
				bc.globalCompositeOperation = 'destination-over';
				bc.globalAlpha = 0.2;
				bc.drawImage(logo, canvas.width/2-(150*canvasRatio)/2-10*canvasRatio, canvas.height/2-(150*canvasRatio)/2+2*canvasRatio, 150*canvasRatio, 150*canvasRatio);
				bc.globalAlpha = 1;
				
				// Code to show important days as markers
				if(importantDays.length > 0) {
					bc.save();
					bc.globalCompositeOperation = 'source-atop';
					bc.fillStyle = 'rgba(0, 0, 0, 1)';
					for(var i=0; i < importantDays.length; i+=1) {
						var time = importantDays[i];
						var ratio1 = ((time-12*60*60*1000) - now)/(daysBefore*24*60*60*1000)+percentage;
						var ratio2 = ((time+12*60*60*1000) - now)/(daysBefore*24*60*60*1000)+percentage;
						if(ratio1 <= 0 || ratio2 >= 1) continue;
						
						bc.beginPath();
							bc.arc(canvas.width/2, canvas.height/2, 200*canvasRatio, Math.PI*2*ratio1, Math.PI*2*ratio2, false);
							bc.lineTo(canvas.width/2, canvas.height/2);
						bc.closePath();
						bc.fill();
					}
					bc.restore();
				}
				
			c.restore();
			bc.restore();
		}
		counter++;
	};
	redraw();
	
	global.onload = function () {
		startTime = new Date().getTime();
		hasLoaded = true;
		var plusone = global.document.createElement('script');
		plusone.src = "https://apis.google.com/js/plusone.js";
		global.document.body.appendChild(plusone);
	};
})(window);
